import 'dart:convert';
import 'dart:io';

import 'package:path/path.dart';

// ignore_for_file: avoid_print

String kClassField = '__class__';

void main(List<String> arguments) {
  exitCode = 0;
  final paths = arguments;

  if (paths.isEmpty) {
    print('No input files specified');
    exitCode = 1;
  } else {
    generate(paths);
  }
}

String outputKey(String s) {
  String out = lowerFirst(s);
  if (out == 'switch') return 'switchVar';
  return out;
}

String lowerFirst(String s) => s[0].toLowerCase() + s.substring(1);

String upperFirst(String s) => s[0].toUpperCase() + s.substring(1).toLowerCase();

String toCamelCase(String s) {
  List<String> strings = s.split('_');
  String output = strings.fold('', (pv, element) => pv + upperFirst(element));
  return output;
}

Future generate(List<String> paths) async {
  print('// Autogenerated file. Do not edit.');
  print('');
  print('// ignore_for_file: camel_case_types');
  print('// ignore_for_file: non_constant_identifier_names');
  print('');
  print("import '../handmade/json_model.dart';");

  for (var path in paths) {
    try {
      File(path)
          .readAsString()
          .then((value) => json.decode(value))
          .then((value) => generateClass(basename(path), value));
    } catch (_) {
      await _handleError(path);
    }
  }
}

String _type(Object o, String className, String paramName) =>
    o is Map || o is List ? '$className$paramName' : _basicType(o);

bool _isBasicType(Object o) => !(o is Map || o is List);

String _basicType(Object o) {
  if (o is String) {
    List<String> split = o.split(':');
    if (split.length == 3 && split[1] == 'default') {
      String type = split[0];
      if (['String', 'int', 'double'].contains(type)) return type;
    }
  }
  return o.runtimeType.toString();
}

int mapHashCode(Map<String, String> m) {
  const int prime = 31;
  List<String> keys = m.keys.toList()..sort();
  int result = keys.fold(1, (pv, key) => (pv * prime + key.hashCode) * prime + m[key].hashCode);
  return result.toInt();
}

class Class {
  String name = '';
  String outputName = '';
  Map<String, dynamic> data = <String, dynamic>{};
  Map<String, dynamic> fields = <String, dynamic>{};
  Map<String, String> fieldTypes = <String, String>{};
  bool generated = false;

  Class(this.name, this.data) : outputName = name;

  void add(String key, Object value) {
    fields[key] = value;
    fieldTypes[key] = _basicType(value);
  }

  @override
  bool operator ==(Object other) {
    if (other is Class) {
      for (String key in fieldTypes.keys) {
        if (!other.fieldTypes.keys.contains(key)) return false;
        if (fieldTypes[key] != other.fieldTypes[key]) return false;
      }
      for (String key in other.fieldTypes.keys) {
        if (!fieldTypes.keys.contains(key)) return false;
        if (fieldTypes[key] != other.fieldTypes[key]) return false;
      }
    }
    return true;
  }

  @override
  int get hashCode => mapHashCode(fieldTypes);

  String get hexHash => BigInt.from(hashCode).toUnsigned(64).toRadixString(16);

  void declareVariables() {
    // Declare the variables
    fields.forEach((key, value) {
      if (key == kClassField) return;
      String ccKey = outputKey(key);
      if (value is Map) {
        Class? aClass = value[kClassField];
        assert(null != aClass);
        print('\t${aClass!.outputName} $ccKey;');
      } else if (value is List) {
        if (value.isEmpty) return;
        Object first = value[0];
        if (first is Map) {
          Class? aClass = first[kClassField];
          assert(null != aClass);
          print('\tList<${aClass!.outputName}> $ccKey;');
        } else {
          print('\tList<${_basicType(first)}> $ccKey;');
        }
      } else {
        assert(fieldTypes.containsKey(key));
        String type = fieldTypes[key]!;
        print('\t$type $ccKey;');
      }
    });
  }

  void constructorWithFields() {
    print('');
    print('\t$outputName.fromFields(');
    data.forEach((key, value) {
      // TODO: Decide what to do with empty arrays later
      if (value is List && value.isEmpty) return;
      if (key == kClassField) return;
      String ccKey = outputKey(key);
      print('\t\tthis.$ccKey,');
    });
    print('\t) : super({});');
  }

  String getType(dynamic value) {
    if (_isBasicType(value)) return _basicType(value);
    if (value is Map) {
      Class? aClass = value[kClassField];
      if (null != aClass) return aClass.outputName;
    }
    return 'Die';
  }

  String defaultValue(dynamic value) {
    if (value is double) return '0.0';
    if (value is int) return '0';
    if (value is bool) return 'false';
    if (value is String) {
      List<String> split = value.split(':');
      if (split.length == 3 && split[1] == 'default') return split[2];
    }
    return '\'\'';
  }

  void blankConstructor() {
    // generate base constructor from Map created by json.decode
    print('');
    print('\t$outputName.blank()');
    String prefix = '\t\t\t: ';
    data.forEach((key, value) {
      if (key == kClassField) return;
      String ccKey = outputKey(key);
      if (value is Map) {
        String subType = getType(value);
        print('$prefix$ccKey = $subType.blank(),');
      } else if (value is List) {
        // TODO: Decide what to do with empty arrays later
        if (value.isEmpty) return;
        print('$prefix$ccKey = [],');
      } else {
        String out = defaultValue(value);
        print('$prefix$ccKey = $out,');
      }
      prefix = '\t\t\t  ';
    });
    print('${prefix}super({});');
  }

  void baseConstructor() {
    // generate base constructor from Map created by json.decode
    print('');
    print('\t$outputName.base(Map<String, dynamic> jsonData)');
    String prefix = '\t\t\t: ';
    data.forEach((key, value) {
      if (key == kClassField) return;
      value ??= '';
      String ccKey = outputKey(key);
      if (value is Map) {
        String subType = getType(value);
        print('$prefix$ccKey = $subType(JSONModel.getMap(jsonData, \'$key\')),');
      } else if (value is List) {
        // TODO: Decide what to do with empty arrays later
        if (value.isEmpty) return;
        var first = value[0];
        if (first is Map) {
          String subType = getType(first);
          print('$prefix$ccKey = JSONModel.getList<$subType>(jsonData, \'$key\',');
          print('(dynamic o) => o is Map ?');
          print('$subType(JSONModel.mapMap(o)) : $subType.blank(),),');
        } else if (first is List) {
          print('Unhandled $key');
        } else {
          String subType = _type(first, outputName, key);
          print('$prefix$ccKey = JSONModel.getList<$subType>(jsonData, \'$key\',');
          print('(dynamic o) => JSONModel.getType<$subType>(o)),');
        }
      } else {
        String type = _type(value, outputName, key);
        print('$prefix$ccKey = JSONModel.get$type(jsonData, \'$key\', defaultValue: ${defaultValue(value)}),');
      }
      prefix = '\t\t\t  ';
    });
    print('${prefix}super(jsonData);');
  }

  void mainConstructor() {
    // main constructor calls base constructor
    print('');
    print('\t$outputName(Map<String, dynamic> jsonData)');
    print('\t\t: this.base(JSONModel.caseInsensitiveMap(jsonData));');
  }

  void toJSONMethod() {
    // return a JSON object
    print('');
    print('\t@override');
    print('\tMap<String, dynamic> toJSON() {');
    data.forEach((key, value) {
      if (key == kClassField) return;
      String ccKey = outputKey(key);
      if (value is Map) {
        print('\t\tjsonData[\'$key\'] = $ccKey.toJSON();');
      } else if (value is List) {
        if (value.isNotEmpty) print('\t\tjsonData[\'$key\'] = JSONModel.jsonItem($ccKey);');
      } else {
        print('\t\tjsonData[\'$key\'] = $ccKey;');
      }
    });
    print('');
    print('\t\treturn jsonData;');
    print('\t}');
  }

  void overrideHashCodeMethod() {
    print('');
    print('\t@override');
    print('\tint get hashCode {');
    int len = 0;
    String singleKey = '';
    data.forEach((key, value) {
      if (key == kClassField) return;
      String ccKey = outputKey(key);
      singleKey = ccKey;
      len += 1;
    });
    if (len == 0) {
      print('\t\treturn jsonData.hashCode;');
    } else if (len == 1) {
      print('\t\treturn $singleKey.hashCode;');
    } else {
      print('\t\tList<Object> o = [');
      data.forEach((key, value) {
        if (key == kClassField) return;
        String ccKey = outputKey(key);
        if (value is Map) {
          if (value.isNotEmpty) print('\t\t\t$ccKey,');
        } else if (value is List) {
          if (value.isNotEmpty) print('\t\t\tmodelHashList($ccKey),');
        } else {
          print('\t\t$ccKey,');
        }
      });
      print('\t\t];');
      print('\t\treturn modelHashList(o);');
    }
    print('\t}');
  }

  void deepCopy() {
    print('');
    print('\t$outputName get clone {');
    print('\t\treturn $outputName.blank()..copy(this);');
    print('\t}');
    print('');
    print('\t@override');
    print('\tvoid copy(covariant $outputName o) {');
    print('\t\tsuper.copy(o);');
    data.forEach((key, value) {
      if (key == kClassField) return;
      String ccKey = outputKey(key);
      if (value is Map) {
        if (value.isNotEmpty) {
          print('\t\t$ccKey.copy(o.$ccKey);');
        }
      } else if (value is List) {
        if (value.isNotEmpty) {
          var first = value.first;
          if (first is Map) {
            print('\t\t$ccKey = o.$ccKey.map((e) => e.clone).toList();');
          } else {
            print('\t\t$ccKey = o.$ccKey.map((e) => e).toList();');
          }
        }
      } else {
        print('\t\t$ccKey = o.$ccKey;');
      }
    });
    print('\t}');
    print('');
  }

  void overrideEqualsMethod() {
    print('');
    print('\t@override');
    print('\tbool operator ==(Object? other) {');
    // print('\t\tif (other == null) return false;');
    print('\t\tif ((other is! $outputName)) return false;');
    int len = 0;
    data.forEach((key, value) {
      if (key == kClassField) return;
      String ccKey = outputKey(key);
      if (len == 0) {
        print('\t\t$outputName o = other;');
      }
      if (value is Map) {
        if (value.isNotEmpty) print('\t\tif ($ccKey != o.$ccKey) return false;');
      } else if (value is List) {
        if (value.isNotEmpty) print('\t\tif (!modelListEquals($ccKey, o.$ccKey)) return false;');
      } else {
        print('\t\tif ($ccKey != o.$ccKey) return false;');
      }
      len++;
    });
    print('');
    print('\t\treturn true;');
    print('\t}');
  }

  void overrideCompareTo() {
    print('');
    print('\t@override');
    print('\tint compareTo(other) {');
    print('\t\tif (other is! $outputName) { return toString().compareTo(other.toString()); }');
    print('\t\tint ret = 0;');
    int len = 0;
    data.forEach((key, value) {
      if (key == kClassField) return;
      String ccKey = outputKey(key);
      if (len == 0) {
        print('\t\t$outputName o = other;');
      }
      if (value is List) {
        if (value.isNotEmpty) print('\t\tif (ret == 0) { ret = modelListCompareTo($ccKey, o.$ccKey); }');
      } else {
        print('\t\tif (ret == 0) { ret = $ccKey.compareTo(o.$ccKey); }');
      }
      len++;
    });
    print('');
    print('\t\treturn ret;');
    print('\t}');
  }

  void staticFactoryMethod() {
    // static / factory method
    print('');
    print('\tstatic $outputName create(Map<String, dynamic> jsonData) {');
    print('\t\treturn $outputName(jsonData);');
    print('\t}');
  }

  void generate() {
    generated = true;
    print('');
    print('class $outputName extends JSONModel {');
    print('\tstatic JSONModelFactory<$outputName> factory = JSONModelFactory(create);');
    print('');
    declareVariables();
    blankConstructor();
    constructorWithFields();
    baseConstructor();
    mainConstructor();
    toJSONMethod();
    overrideHashCodeMethod();
    overrideEqualsMethod();
    deepCopy();
    overrideCompareTo();
    staticFactoryMethod();
    print('}');
  }
}

class ClassManager {
  Map<String, Class> classHashMap = <String, Class>{};
  Map<String, Class> classNameMap = <String, Class>{};

  Set<String> namesUsed = <String>{};
  Map<String, String> hashToName = <String, String>{};

  void createUniqueName(String base, String hash) {
    String proposedName = '${base}Field';
    int i = 0;
    while (namesUsed.contains(proposedName)) {
      proposedName = '${base}Field$i';
      i++;
    }
    namesUsed.add(proposedName);
    hashToName[hash] = proposedName;
  }

  void findClassesInList(String baseName, String paramName, List<dynamic> data, int level) {
    if (data.isEmpty) return;
    var value = data.first;
    if (value is Map) findClasses(baseName, paramName, value as Map<String, dynamic>, level + 1);
  }

  void findClasses(String baseName, String paramName, Map<String, dynamic> data, int level) {
    String originalName = baseName + paramName;
    Class hashClass = Class(originalName, data);
    bool allBasicTypes = true;

    data.forEach((key, value) {
      if (key == kClassField) return;
      value ??= '';
      hashClass.add(key, value);
      if (!_isBasicType(value)) allBasicTypes = false;
    });

    if (allBasicTypes) {
      String hashName = hashClass.hexHash;
      if (classHashMap.containsKey(hashName)) {
        Class inMap = classHashMap[hashName]!;
        hashClass = inMap;
        if (level != 0) hashClass.outputName = hashToName[hashName]!;
      } else {
        createUniqueName(baseName, hashName);
        classHashMap[hashName] = hashClass;
      }
    }
    classNameMap[originalName] = hashClass;
    data[kClassField] = hashClass;
    if (!allBasicTypes) {
      data.forEach((key, value) {
        if (key == kClassField) return;
        value ??= '';
        if (!_isBasicType(value)) {
          if (value is Map) findClasses(originalName, key, value as Map<String, dynamic>, level + 1);
          if (value is List) findClassesInList(originalName, key, value, level + 1);
        }
      });
    }
  }

  Class getClass(String baseName, String paramName) {
    Class? aClass = classNameMap[baseName + paramName];
    assert(null != aClass);
    return aClass!;
  }

  void generate() {
    for (Class aClass in classHashMap.values) {
      classHashMap.values.fold<int>(0, (ndx, subClass) {
        if (ndx > 0 && subClass.outputName == aClass.outputName) {
          subClass.outputName += ndx.toString();
          return ndx + 1;
        }
        return ndx;
      });
    }
    for (Class aClass in classHashMap.values) {
      aClass.generate();
    }
    for (Class aClass in classNameMap.values) {
      if (!aClass.generated && !classHashMap.containsKey(aClass.name)) aClass.generate();
    }
  }
}

void generateClass(String fn, Map<String, dynamic> data) {
  String className = toCamelCase(fn).split('.')[0];

  ClassManager mgr = ClassManager();
  mgr.findClasses(className, '', data, 0);
  mgr.generate();
}

Future _handleError(String path) async {
  if (await FileSystemEntity.isDirectory(path)) {
    stderr.writeln('error: $path is a directory');
  } else {
    exitCode = 2;
  }
}
